LDmicro0.2
MICRO=Microchip PIC16F876 28-PDIP or 28-SOIC
CYCLE=10000 us at Timer1, YPlcCycleDuty:0, ConfigurationWord(s):0x3F72
CRYSTAL=20000000 Hz
BAUD=19200 Hz, RATE=1000000 Hz, SPEED=400000 Hz
COMPILED=C:\Users\User\Downloads\Manuel\PIC16\Pic876\Manuel-876-v8.c
COMPILER=HI_TECH_C

PULL-UP LIST
    RA: 0x0 
    RB: 0x0 
    RC: 0x0 
END

VAR LIST
    1 bytes #TRISA
    1 bytes #TRISB
    2 bytes Cdate
    2 bytes Reg1
    2 bytes Reg2
    2 bytes Reg3
    2 bytes Reg4
    2 bytes Reg5
    2 bytes Select
    2 bytes date
    1 bytes day
    1 bytes hour
    2 bytes min
END

IO LIST
    XDate at 5 0 0
    XDay at 4 0 0
    XHour at 2 0 0
    XMin at 3 0 0
    XMonth at 6 0 0
    Y1_D at 21 0 0
    Y2_L at 22 0 0
    Y3_M at 23 0 0
    Y4_MI at 24 0 0
    Y5_J at 25 0 0
    Y6_V at 26 0 0
    Y7_S at 27 0 0
    I2C_SCL at 14 0 0
    I2C_SDA at 15 0 0
END

PROGRAM
RUNG 1
  MOVE #TRISA 0x1F
END
RUNG 2
  MOVE #TRISB 0
END
RUNG 3
  EQU Select 0
  I2C_RD I2C - Reg1 Master 0x68 0x01 MSB 400000
  BCD2BIN min Reg1
END
RUNG 4
  EQU Select 1
  I2C_RD I2C - Reg2 Master 0x68 0x02 MSB 400000
  BCD2BIN hour Reg2
END
RUNG 5
  EQU Select 4
  I2C_RD I2C - Reg3 Master 0x68 0x03 MSB 400000
  BCD2BIN day Reg3
END
RUNG 6
  EQU Select 2
  I2C_RD I2C - Reg4 Master 0x68 0x04 MSB 400000
  BCD2BIN date Reg4
END
RUNG 7
  EQU Select 3
  I2C_RD I2C - Reg5 Master 0x68 0x05 MSB 400000
  BCD2BIN month Reg5
END
RUNG 8
  CONTACTS XMin 0 0
  CONTACTS R400 0 0
  OSR
  PARALLEL
    MOVE t_min min
    ADD t_min t_min 1
    SERIES
      GRT t_min 59
      MOVE t_min 0
    END
    MOVE min t_min
    SERIES
      BIN2BCD Reg1 min
      I2C_WR I2C Reg1 - Master 0x68 0x01 MSB 400000
    END
  END
END
RUNG 9
  CONTACTS XHour 0 0
  CONTACTS R400 0 0
  OSR
  PARALLEL
    MOVE t_hour hour
    ADD t_hour t_hour 1
    SERIES
      GRT t_hour 23
      MOVE t_hour 0
    END
    MOVE hour t_hour
    SERIES
      BIN2BCD Reg2 hour
      I2C_WR I2C Reg2 - Master 0x68 0x02 MSB 400000
    END
  END
END
RUNG 10
  CONTACTS XDay 0 0
  CONTACTS R400 0 0
  OSR
  PARALLEL
    MOVE t_day day
    ADD t_day t_day 1
    SERIES
      GRT t_day 7
      MOVE t_day 1
    END
    MOVE day t_day
    SERIES
      BIN2BCD Reg3 day
      I2C_WR I2C Reg3 - Master 0x68 0x03 MSB 400000
    END
  END
END
RUNG 11
  CONTACTS XDate 0 0
  CONTACTS R400 0 0
  OSR
  PARALLEL
    MOVE Cdate date
    ADD Cdate Cdate 1
    SERIES
      GRT Cdate 31
      MOVE Cdate 1
    END
    MOVE date Cdate
    SERIES
      BIN2BCD Reg4 date
      I2C_WR I2C Reg4 - Master 0x68 0x04 MSB 400000
    END
  END
END
RUNG 12
  CONTACTS XMonth 0 0
  CONTACTS R400 0 0
  OSR
  PARALLEL
    MOVE t_month month
    ADD t_month t_month 1
    SERIES
      GRT t_month 12
      MOVE t_month 1
    END
    MOVE month t_month
    SERIES
      BIN2BCD Reg5 month
      I2C_WR I2C Reg5 - Master 0x68 0x05 MSB 400000
    END
  END
END
RUNG 13
  SHORT
  PARALLEL
    SERIES
      EQU day 1
      COIL Y1_D 0 0 0 0
    END
    SERIES
      EQU day 2
      COIL Y2_L 0 0 0 0
    END
    SERIES
      EQU day 3
      COIL Y3_M 0 0 0 0
    END
    SERIES
      EQU day 4
      COIL Y4_MI 0 0 0 0
    END
    SERIES
      EQU day 5
      COIL Y5_J 0 0 0 0
    END
    SERIES
      EQU day 6
      COIL Y6_V 0 0 0 0
    END
    SERIES
      EQU day 7
      COIL Y7_S 0 0 0 0
    END
  END
END
RUNG 14
  MOVE sdata 0
END
RUNG 15
  EQU Select 0
  MOVE sdata min
END
RUNG 16
  EQU Select 1
  MOVE sdata hour
END
RUNG 17
  EQU Select 1
  SET_BIT sdata 6
END
RUNG 18
  EQU Select 2
  MOVE sdata date
END
RUNG 19
  EQU Select 2
  SET_BIT sdata 7
END
RUNG 20
  EQU Select 3
  MOVE sdata month
END
RUNG 21
  EQU Select 3
  SET_BIT sdata 7
  SET_BIT sdata 6
END
RUNG 22
  NEQ Select 4
  UART_SEND sdata 1 1
END
RUNG 23
  ADD Select Select 1
END
RUNG 24
  EQU Select 5
  MOVE Select 0
END
